module MinxingRubySdk
  class Account

    attr_accessor :connection

    def get(url, withTokenHeader=true, headers, params)
      apiForResponse('get', url, withTokenHeader, headers, params)
    end

    def post(url, withTokenHeader=true, headers, params)
      apiForResponse('post', url, withTokenHeader, headers, params)
    end

    def put(url, withTokenHeader=true, headers, params)
      apiForResponse('put', url, withTokenHeader, headers, params)
    end

    def delete(url, withTokenHeader=true, headers, params)
      apiForResponse('delete', url, withTokenHeader, headers, params)
    end


    def apiForResponse(method, url, withTokenHeader, headers, params)
      method = 'get' if method.empty?
      method = method.downcase
      if withTokenHeader
        @connection.tokenType = "Bearer" if @connection.tokenType.empty?

        headers['Authorization'] =  @connection.tokenType + " " + @connection.token
        # headers["API-RemoteIP"] =  ipaddr.getHostAddress()
        # client.getHostConfiguration().getParams()
        #     .setParameter("http.default-headers", headers);
      end
      response = @connection.connection.send(method) do |req|
        LOGGER.debug(url)
        LOGGER.debug(headers)
        LOGGER.debug(params)

        req.url url
        req.headers = headers
        req.body = params
      end

      response.body

    end

  end
end
