
module MinxingRubySdk
  module Api
    class Login
      attr_reader :connection, :root_url, :token

      def initialize(root_url)
      	@root_url = root_url
        @connection = MinxingRubySdk::Connection.new root_url
      end

      def get_token_json (args)
        response = @connection.connection.post do |req|
          req.url @root_url + MinxingRubySdk::SETTINGS['api']['access_token_url']
          req.headers['Content-Type'] = 'application/x-www-form-urlencoded'
          req.body = args
        end

        @token = JSON response.body
      end

      def from_last_seen
        response = @connection.connection.get do |req|
          req.url @root_url + MinxingRubySdk::SETTINGS['api']['api_prefix'] + MinxingRubySdk::SETTINGS['api']['from_last_seen']
          req.headers['AUTHORIZATION'] = 'bearer ' + @token['access_token']
        end
        JSON response.body
      end

      def subscriptions_ocus(ocu_id)
      	response = @connection.connection.post do |req|
          req.url @root_url + MinxingRubySdk::SETTINGS['api']['api_prefix'] + MinxingRubySdk::SETTINGS['api']['subscriptions_ocus'] + '/' + ocu_id
          req.headers['AUTHORIZATION'] = 'bearer ' + @token['access_token']
        end
        puts response.body
      end

      def post_conversations_messages(conversation_id,message_content)
      	params = {}
      	params['body'] = message_content
      	response = @connection.connection.post do |req|
          req.url @root_url + MinxingRubySdk::SETTINGS['api']['api_prefix'] + MinxingRubySdk::SETTINGS['api']['post_conversations_messages'].sub('id',conversation_id)
          req.headers['AUTHORIZATION'] = 'bearer ' + @token['access_token']
          req.body = params
        end
      end
    end
  end
end
