module MinxingRubySdk
  module Ocu
    class ArticleMessage < Message
      attr_accessor :articles

      def initialize
        @articles = []
      end

      def body
        size = @articles.size
        if size > 0
          json = '{"article_count":' + size.to_s + ',"articles":['
          for i in 0...size
            if i>0
              json += ','
            end
            json += '{'
            if articles[i].type == 'resource'
              json += resource_article_json(articles[i])
            else
              json += common_article_json(articles[i])
            end
            json += '}'

          end
          json +=']}'
        end
        json
      end

      def common_article_json(article)
        json = ""
        json += '"title":"' + article.title + '"' unless article.title.nil?
        json += ',"description":"' + article.description + '"' unless article.description.nil?
        json += ',"pic_url":"' + article.pic_url  + '"' unless article.pic_url.nil?
        json += ',"url":"' + article.url + '"' unless article.url.nil?
        json += ',"app_url":"' + article.app_url + '"' unless article.app_url.nil?
        json
      end
      def resource_article_json(article)
        json = ""
        json += '"type":"' + article.type + '"'  unless article.type.nil?
        json += ',"resource_id":"' + article.resource_id.to_s + '"' unless article.resource_id.nil?
        json
      end
    end
  end
end
